/*
 * RealSpaceMatrixSymmetricValidator.hpp
 *
 *  Created on: May 10, 2012
 *      Author: heber
 */

#ifndef REALSPACEMATRIXSYMMETRICVALIDATOR_HPP_
#define REALSPACEMATRIXSYMMETRICVALIDATOR_HPP_


// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "LinearAlgebra/RealSpaceMatrix.hpp"

#include "Parameters/Validators/Validator.hpp"

/** This validator checks whether the given RealSpaceMatrix is symmetric.
 *
 */
class RealSpaceMatrixSymmetricValidator : public Validator<RealSpaceMatrix>
{
  bool isValid(const RealSpaceMatrix & _value) const;
  bool operator==(const Validator<RealSpaceMatrix> &_instance) const;
  Validator< RealSpaceMatrix >* clone() const;
};

#endif /* REALSPACEMATRIXSYMMETRICVALIDATOR_HPP_ */
